open Coloration_graphe ;;

let g1 : graphe =
  [|
    (* 0 *) [1 ; 2 ; 3 ; 4 ] ;
    (* 1 *) [0 ; 2 ] ;
    (* 2 *) [0 ; 1 ; 4] ;
    (* 3 *) [0 ; 4] ;
    (* 4 *) [0 ; 2 ; 3 ] ;
  |];;

let g2 : graphe =
  [|
    (* 0 *) [3 ; 5 ; 7 ; 9] ;
    (* 1 *) [2 ; 4 ; 6 ; 8] ;
    (* 2 *) [1 ; 5 ; 7 ; 9] ;
    (* 3 *) [0 ; 4 ; 6 ; 8] ;
    (* 4 *) [1 ; 3 ; 7 ; 9] ;
    (* 5 *) [0 ; 2 ; 6 ; 8] ;
    (* 6 *) [3 ; 5 ; 1 ; 9] ;
    (* 7 *) [0 ; 2 ; 4 ; 8] ;
    (* 8 *) [1 ; 5 ; 7 ; 3] ;
    (* 9 *) [0 ; 2 ; 4 ; 6] ;
  |];;

let g3 : graphe =
  [|
    (* 0 *) [1 ; 2 ; 3 ; 4] ;
    (* 1 *) [0 ; 2 ; 3 ; 4] ;
    (* 2 *) [0 ; 1 ; 3 ; 4] ;
    (* 3 *) [0 ; 1 ; 2 ; 4] ;
    (* 4 *) [0 ; 1 ; 2 ; 3] ;
  |];;

let s_couleur ( c : couleur array ) : string =
  String.concat "--"
    ( List.map
        ( fun c -> match c with
            | AUCUNE -> "-1"
            | COULEUR(k) -> string_of_int k )
        ( Array.to_list c ) ) ;;

Printf.printf "Question 1 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> if ( est_2_coloriable g ) then "Oui" else "Non" )
          [g1 ; g2 ; g3  ] ) ) ;;

Printf.printf "Question 2 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> s_couleur ( coloration_glouton g ) )
          [g1 ; g2 ; g3  ] ) ) ;;

Printf.printf "Question 3 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> s_couleur ( coloration_welsh_powell g ) )
          [g1 ; g2 ; g3  ] ) ) ;;

Printf.printf "Question 4 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> if ( est_3coloriable g ) then "Oui" else "Non" )
          [g1 ; g2 ; g3  ] ) ) ;;

Printf.printf "Question 4 : \n|- %s\n"
  ( String.concat "\n|- "
      ( List.map
          ( fun g -> string_of_int ( nombre_chromatique g ) )
          [g1 ; g2 ; g3 ] ) ) ;;
